Package org.springframework.web.servlet

# Class NoHandlerFoundException

java.lang.Object
java.lang.Throwable
java.lang.Exception
jakarta.servlet.ServletException
org.springframework.web.servlet.NoHandlerFoundException

All Implemented Interfaces:
  `Serializable`, `org.springframework.web.ErrorResponse`

public class NoHandlerFoundException extends ServletException implements org.springframework.web.ErrorResponse
Thrown when the `DispatcherServlet` can't find a handler for a request, which may be handled with a configured `HandlerExceptionResolver`.

Since:
  4.0
Author:
  Brian Clozel
See Also:
  - `DispatcherServlet.noHandlerFound(HttpServletRequest, HttpServletResponse)`
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.springframework.web.ErrorResponse

`org.springframework.web.ErrorResponse.Builder, org.springframework.web.ErrorResponse.Interceptor`

## Constructor Summary

Constructors
Constructor
Description
`NoHandlerFoundException(String httpMethod, String requestURL, org.springframework.http.HttpHeaders headers)`
Constructor for NoHandlerFoundException.

## Method Summary

Modifier and Type
Method
Description
`org.springframework.http.ProblemDetail`
`getBody()`
`org.springframework.http.HttpHeaders`
`getHeaders()`
Return headers to use for the response.
`String`
`getHttpMethod()`
`org.springframework.http.HttpHeaders`
`getRequestHeaders()`
Return the headers of the request.
`String`
`getRequestURL()`
`org.springframework.http.HttpStatusCode`
`getStatusCode()`

### Methods inherited from class jakarta.servlet.ServletException

`getRootCause`

### Methods inherited from class java.lang.Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.springframework.web.ErrorResponse

`getDetailMessageArguments, getDetailMessageArguments, getDetailMessageCode, getTitleMessageCode, getTypeMessageCode, updateAndGetBody`

## Constructor Details

### NoHandlerFoundException

public NoHandlerFoundException(String httpMethod, String requestURL, org.springframework.http.HttpHeaders headers)
Constructor for NoHandlerFoundException.

Parameters:
  `httpMethod` - the HTTP method
  `requestURL` - the HTTP request URL
  `headers` - the HTTP request headers

## Method Details

### getStatusCode

public org.springframework.http.HttpStatusCode getStatusCode()

Specified by:
  `getStatusCode` in interface `org.springframework.web.ErrorResponse`

### getHttpMethod

public String getHttpMethod()

### getRequestURL

public String getRequestURL()

### getHeaders

public org.springframework.http.HttpHeaders getHeaders()
Return headers to use for the response.

Note: As of 6.0 this method overlaps with `ErrorResponse.getHeaders()` and therefore no longer returns request headers. Use `getRequestHeaders()` instead for request headers.

Specified by:
  `getHeaders` in interface `org.springframework.web.ErrorResponse`

### getRequestHeaders

public org.springframework.http.HttpHeaders getRequestHeaders()
Return the headers of the request.

Since:
  6.0.3

### getBody

public org.springframework.http.ProblemDetail getBody()

Specified by:
  `getBody` in interface `org.springframework.web.ErrorResponse`